diff -r 1b0b563a81e6 mcabber/mcabber/commands.c
--- a/mcabber/mcabber/commands.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/commands.c	Wed May 15 12:48:30 2013 +0300
@@ -1285,6 +2169,7 @@
   gint retval = 0;
   int isroom;
   gpointer xep184 = NULL;
+  LmMessageSubType type_overwrite = LM_MESSAGE_SUB_TYPE_NOT_SET;
 
   if (!xmpp_is_online()) {
     scr_LogPrint(LPRINT_NORMAL, "You are not connected.");
@@ -1299,11 +2184,15 @@
     return 1;
   }
   if (check_jid_syntax((char*)fjid)) {
-    scr_LogPrint(LPRINT_NORMAL|LPRINT_NOTUTF8,
-                 "<%s> is not a valid Jabber ID.", fjid);
+    scr_LogPrint(LPRINT_NORMAL, "<%s> is not a valid Jabber ID.", fjid);
     return 1;
   }
 
+  if (msg_type == msgtype_normal)
+    type_overwrite = LM_MESSAGE_SUB_TYPE_NORMAL;
+  else if (msg_type == msgtype_headline)
+    type_overwrite = LM_MESSAGE_SUB_TYPE_HEADLINE;
+
   // We must use the bare jid in hk_message_out()
   rp = strchr(fjid, JID_RESOURCE_SEPARATOR);
   if (rp)
@@ -1351,213 +2240,221 @@
   return retval;
 }
 
-//  send_message(msg, subj, type_overwrite)
-// Write the message in the buddy's window and send the message on
-// the network.
-static void send_message(const char *msg, const char *subj,
-                         LmMessageSubType type_overwrite)
+static void say_cmd(char *arg)
 {
-  const char *bjid;
-  char *jid;
-  const char *activeres;
-
+  // it is current buddy
   if (!current_buddy) {
-    scr_LogPrint(LPRINT_NORMAL, "No buddy is currently selected.");
+    scr_log_print (LPRINT_NORMAL, "No buddy selected.");
+    return;
+  } else if (!(buddy_gettype (BUDDATA(current_buddy)) & cmdarg_roster_entity)) {
+    scr_log_print (LPRINT_NORMAL, "Currently selected buddy is of wrong type.");
     return;
   }
 
-  bjid = CURRENT_JID;
-  if (!bjid) {
-    scr_LogPrint(LPRINT_NORMAL, "No buddy is currently selected.");
-    return;
-  }
-
-  activeres = buddy_getactiveresource(BUDDATA(current_buddy));
-  if (activeres)
-    jid = g_strdup_printf("%s/%s", bjid, activeres);
-  else
-    jid = g_strdup(bjid);
-
-  send_message_to(jid, msg, subj, type_overwrite, FALSE);
-  g_free(jid);
-}
-
-static LmMessageSubType scan_mtype(char **arg)
-{
-  // Try splitting it
-  char **parlist = split_arg(*arg, 2, 1);
-  LmMessageSubType result = LM_MESSAGE_SUB_TYPE_NOT_SET;
-  // Is it a good parameter?
-  if (parlist && *parlist) {
-    if (!strcmp("-n", *parlist)) {
-      result = LM_MESSAGE_SUB_TYPE_NORMAL;
-    } else if (!strcmp("-h", *parlist)) {
-      result = LM_MESSAGE_SUB_TYPE_HEADLINE;
-    }
-    if (result != LM_MESSAGE_SUB_TYPE_NOT_SET || (!strcmp("--", *parlist)))
-      *arg += strlen(*arg) - (parlist[1] ? strlen(parlist[1]) : 0);
-  }
-  // Anything found? -> skip it
-  free_arg_lst(parlist);
-  return result;
-}
-
-void say_cmd(char *arg, int parse_flags)
-{
-  gpointer bud;
-  LmMessageSubType msgtype = LM_MESSAGE_SUB_TYPE_NOT_SET;
-
   scr_set_chatmode(TRUE);
   scr_show_buddy_window();
 
-  if (!current_buddy) {
-    scr_LogPrint(LPRINT_NORMAL,
-                 "Whom are you talking to?  Please select a buddy.");
-    return;
+  buddy_setflags(bud, ROSTER_FLAG_LOCK, TRUE);
+
+  const char *resource = buddy_getactiveresource (BUDDATA(current_buddy));
+  const char *jid      = buddy_getjid (BUDDATA(current_buddy));
+  gchar      *fjid     = g_strdup_printf ("%s" JID_RESOURCE_SEPARATORSTR "%s", jid, resource);
+
+  send_message_to (fjid, arg, NULL, msgtype_not_set, FALSE);
+  g_free (fjid);
+}
+
+static gchar *do_say (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_say_msg     = 0,
+  pos_say_msgtype = 1,
+} pos_say_t;
+
+static cmdopts_t def_say = {
+  "say",
+  cmd_default,
+  NULL,
+  do_say,
+  (cmdopt_t[4]){
+    { 'n', "normal",   { "normal",   pos_say_msgtype, cmdarg_switch, NULL, NULL,
+                                     NULL, (gpointer)msgtype_normal}},
+    { 'h', "headline", { "headline", pos_say_msgtype, cmdarg_switch, NULL, NULL,
+                                     NULL, (gpointer)msgtype_headline } },
+    { 'd', "default",  { "default",  pos_say_msgtype, cmdarg_switch, NULL, NULL,
+                                     NULL, (gpointer)msgtype_not_set } },
+    {0}
+  },
+  (cmdarg_t[2]){
+    { "message", pos_say_msg, cmdarg_eol | cmdarg_chreq, NULL,
+                                     &cmdarg_type_nonspace },
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_say (const cmdopts_t *options, cmdarg_value_t *values)
+{
+  say_cmd(values[pos_say_msg].value.arg,
+          (msgtype_t) (values[pos_say_msgtype].src -> userdata));
+  return NULL;
+}
+
+//
+//  /msay
+//
+
+static gchar *do_msay (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  scmd_msay_begin, scmd_msay_verbatim,
+  scmd_msay_send, scmd_msay_send_to,
+  scmd_msay_toggle, scmd_msay_toggle_verbatim,
+  scmd_msay_abort,
+} scmd_msay_t;
+
+typedef enum {
+  pos_msay_scmd    = 0,
+  pos_msay_subject = 1,
+  pos_msay_jid     = 1,
+  pos_msay_msgtype = 2,
+} pos_msay_t;
+
+static cmdopts_t def_msay = {
+  "msay",
+  cmd_default,
+  NULL,
+  do_msay,
+  NULL,
+  (cmdarg_t[2]){
+    { "subcommand", pos_msay_scmd, cmdarg_subcmd|cmdarg_chreq, NULL, NULL },
+    {NULL},
+  },
+  (cmdopts_t[8]){
+    { "begin", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){{"subject", pos_msay_subject, cmdarg_eol, NULL, &cmdarg_type_nonspace}, {NULL}},
+      NULL, (gpointer)scmd_msay_begin },
+    { "verbatim", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){{"subject", pos_msay_subject, cmdarg_eol, NULL, &cmdarg_type_nonspace}, {NULL}},
+      NULL, (gpointer)scmd_msay_verbatim },
+    { "send", cmd_default, NULL, NULL,
+      (cmdopt_t[4]){
+        {'n', "normal",   {"normal",   pos_msay_msgtype, cmdarg_switch, NULL, NULL, NULL, (gpointer)msgtype_normal}},
+        {'h', "headline", {"headline", pos_msay_msgtype, cmdarg_switch, NULL, NULL, NULL, (gpointer)msgtype_headline}},
+        {'d', "default",  {"default",  pos_msay_msgtype, cmdarg_switch, NULL, NULL, NULL, (gpointer)msgtype_not_set}},
+        {0}
+      },
+      NULL, NULL, (gpointer)scmd_msay_send, 0 },
+    { "send_to", cmd_default, NULL, NULL,
+      (cmdopt_t[4]){
+        {'n', "normal",   {"normal",   pos_msay_msgtype, cmdarg_switch, NULL, NULL, NULL, (gpointer)msgtype_normal}},
+        {'h', "headline", {"headline", pos_msay_msgtype, cmdarg_switch, NULL, NULL, NULL, (gpointer)msgtype_headline}},
+        {'d', "default",  {"default",  pos_msay_msgtype, cmdarg_switch, NULL, NULL, NULL, (gpointer)msgtype_not_set}},
+        {0}
+      },
+      (cmdarg_t[2]){{"jid", pos_msay_jid, cmdarg_chreq, NULL, &cmdarg_type_fjid, (gpointer)cmdarg_roster_entity}, {NULL}}, 
+      NULL, (gpointer)scmd_msay_send_to },
+    { "toggle", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_msay_toggle },
+    { "toggle_verbatim", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_msay_toggle_verbatim },
+    { "abort", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_msay_abort },
+  },
+};
+
+static gchar *do_msay (const cmdopts_t *command, cmdarg_value_t *values)
+{
+  const char  *msg;
+  scmd_msay_t subcmd = (scmd_msay_t) (values[pos_msay_scmd].src -> userdata);
+
+  if (subcmd == scmd_msay_toggle) {
+    if (scr_get_multimode())
+      subcmd = scmd_msay_send;
+    else
+      subcmd = scmd_msay_begin;
+  } else if (subcmd == scmd_msay_toggle_verbatim) {
+    if (scr_get_multimode())
+      subcmd = scmd_msay_send;
+    else
+      subcmd = scmd_msay_verbatim;
   }
 
-  bud = BUDDATA(current_buddy);
-  if (!(buddy_gettype(bud) &
-        (ROSTER_TYPE_USER|ROSTER_TYPE_AGENT|ROSTER_TYPE_ROOM))) {
-    scr_LogPrint(LPRINT_NORMAL, "This is not a user.");
-    return;
-  }
-
-  buddy_setflags(bud, ROSTER_FLAG_LOCK, TRUE);
-  if (parse_flags)
-    msgtype = scan_mtype(&arg);
-  arg = to_utf8(arg);
-  send_message(arg, NULL, msgtype);
-  g_free(arg);
-}
-
-static void do_say(char *arg) {
-  say_cmd(arg, 1);
-}
-
-static void do_msay(char *arg)
-{
-  /* Parameters: begin verbatim abort send send_to */
-  char **paramlst;
-  char *subcmd;
-
-  paramlst = split_arg(arg, 2, 1); // subcmd, arg
-  subcmd = *paramlst;
-  arg = *(paramlst+1);
-
-  if (!subcmd || !*subcmd) {
-    scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-    scr_LogPrint(LPRINT_NORMAL, "Please read the manual before using "
-                 "the /msay command.");
-    scr_LogPrint(LPRINT_NORMAL, "(Use \"%s begin\" to enter "
-                 "multi-line mode...)", mkcmdstr("msay"));
-    goto do_msay_return;
-  }
-
-  if (!strcasecmp(subcmd, "toggle")) {
-    if (scr_get_multimode())
-      subcmd = "send";
-    else
-      subcmd = "begin";
-  } else if (!strcasecmp(subcmd, "toggle_verbatim")) {
-    if (scr_get_multimode())
-      subcmd = "send";
-    else
-      subcmd = "verbatim";
-  }
-
-  if (!strcasecmp(subcmd, "abort")) {
+  if (subcmd == scmd_msay_abort) {
     if (scr_get_multimode())
       scr_LogPrint(LPRINT_NORMAL, "Leaving multi-line message mode.");
     scr_set_multimode(FALSE, NULL);
-    goto do_msay_return;
-  } else if ((!strcasecmp(subcmd, "begin")) ||
-             (!strcasecmp(subcmd, "verbatim"))) {
-    bool verbat;
-    gchar *subj_utf8 = to_utf8(arg);
-    if (!strcasecmp(subcmd, "verbatim")) {
-      scr_set_multimode(2, subj_utf8);
-      verbat = TRUE;
+    return NULL;
+  } else if (subcmd == scmd_msay_begin || subcmd == scmd_msay_verbatim) {
+    gchar *subject = values[pos_msay_subject].value.arg;
+
+    if (subcmd == scmd_msay_verbatim) {
+      scr_set_multimode(2, subject);
     } else {
-      scr_set_multimode(1, subj_utf8);
-      verbat = FALSE;
+      scr_set_multimode(1, subject);
     }
 
     scr_LogPrint(LPRINT_NORMAL, "Entered %smulti-line message mode.",
-                 verbat ? "VERBATIM " : "");
+                 subcmd == scmd_msay_verbatim ? "VERBATIM " : "");
     scr_LogPrint(LPRINT_NORMAL, "Select a buddy and use \"%s send\" "
                  "when your message is ready.", mkcmdstr("msay"));
-    if (verbat)
+    if (subcmd == scmd_msay_verbatim)
       scr_LogPrint(LPRINT_NORMAL, "Use \"%s abort\" to abort this mode.",
                    mkcmdstr("msay"));
-    g_free(subj_utf8);
-    goto do_msay_return;
-  } else if (strcasecmp(subcmd, "send") && strcasecmp(subcmd, "send_to")) {
-    scr_LogPrint(LPRINT_NORMAL, "Unrecognized parameter!");
-    goto do_msay_return;
+    return NULL;
   }
 
-  /* send/send_to command */
+  /* scmd_msay_send or scmd_msay_send_to */
 
   if (!scr_get_multimode()) {
-    scr_LogPrint(LPRINT_NORMAL, "No message to send.  "
+    return g_strdup_printf ("No message to send.  "
                  "Use \"%s begin\" first.", mkcmdstr("msay"));
-    goto do_msay_return;
   }
 
   scr_set_chatmode(TRUE);
   scr_show_buddy_window();
 
-  if (!strcasecmp(subcmd, "send_to")) {
-    int err = FALSE;
-    gchar *msg_utf8;
-    LmMessageSubType msg_type = scan_mtype(&arg);
-    // Let's send to the specified JID.  We leave now if there
-    // has been an error (so we don't leave multi-line mode).
-    arg = to_utf8(arg);
-    msg_utf8 = to_utf8(scr_get_multiline());
-    if (msg_utf8) {
-      err = send_message_to(arg, msg_utf8, scr_get_multimode_subj(), msg_type,
-                            FALSE);
-      g_free(msg_utf8);
-    }
-    g_free(arg);
-    if (err)
-      goto do_msay_return;
-  } else { // Send to currently selected buddy
-    gpointer bud;
-    gchar *msg_utf8;
-
-    if (!current_buddy) {
-      scr_LogPrint(LPRINT_NORMAL, "Whom are you talking to?");
-      goto do_msay_return;
-    }
-
-    bud = BUDDATA(current_buddy);
-    if (!(buddy_gettype(bud) &
-          (ROSTER_TYPE_USER|ROSTER_TYPE_AGENT|ROSTER_TYPE_ROOM))) {
-      scr_LogPrint(LPRINT_NORMAL, "This is not a user.");
-      goto do_msay_return;
-    }
-
-    buddy_setflags(bud, ROSTER_FLAG_LOCK, TRUE);
-    msg_utf8 = to_utf8(scr_get_multiline());
-    if (msg_utf8) {
-      send_message(msg_utf8, scr_get_multimode_subj(), scan_mtype(&arg));
-      g_free(msg_utf8);
+  if ((msg = scr_get_multiline())) {
+    msgtype_t msg_type = (msgtype_t) (values[pos_msay_msgtype].src -> userdata);
+
+    if (subcmd == scmd_msay_send_to) {
+      const char *jid = values[pos_msay_jid].value.arg;
+
+      // Let's send to the specified JID.  We leave now if there
+      // has been an error (so we don't leave multi-line mode).
+      if (send_message_to(jid, msg, scr_get_multimode_subj(),
+                          msg_type, FALSE))
+        return NULL;
+    } else { // Send to currently selected buddy
+      gpointer bud;
+
+      if (!current_buddy) {
+        return g_strdup ("Whom are you talking to?");
+      }
+
+      bud = BUDDATA(current_buddy);
+      if (!(buddy_gettype(bud) &
+            (ROSTER_TYPE_USER|ROSTER_TYPE_AGENT|ROSTER_TYPE_ROOM))) {
+        return g_strdup ("This is not a user.");
+      }
+
+      buddy_setflags(bud, ROSTER_FLAG_LOCK, TRUE);
+      send_message(msg, scr_get_multimode_subj(), msg_type);
     }
   }
+
   scr_set_multimode(FALSE, NULL);
   scr_LogPrint(LPRINT_NORMAL, "You have left multi-line message mode.");
-do_msay_return:
-  free_arg_lst(paramlst);
+
+  return NULL;
 }
 
+//
+//  /say_to
+//
+
 //  load_message_from_file(filename)
 // Read the whole content of a file.
 // The data are converted to UTF8, they should be freed by the caller after
 // use.
-char *load_message_from_file(const char *filename)
+char *load_message_from_file(const char *filename, const char *localfn)
 {
   FILE *fd;
   struct stat buf;
@@ -1566,7 +2463,7 @@
   char *next_utf8_char;
   size_t len;
 
-  fd = fopen(filename, "r");
+  fd = fopen(localfn, "r");
 
   if (!fd || fstat(fileno(fd), &buf)) {
     scr_LogPrint(LPRINT_LOGNORM, "Cannot open message file (%s)", filename);
@@ -1632,273 +2529,287 @@
   return msgbuf_utf8;
 }
 
-static void do_say_to(char *arg)
+static gchar *do_say_to (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_sayto_jid     = 0,
+  pos_sayto_msg     = 1,
+  pos_sayto_msgtype = 2,
+  pos_sayto_quiet   = 3,
+  pos_sayto_esc     = 4,
+  pos_sayto_file    = 5,
+} pos_sayto_t;
+
+static cmdopts_t def_say_to = {
+  "say_to",
+  cmd_default,
+  cmd_check_online,
+  do_say_to,
+  (cmdopt_t[7]){
+    {'n', "normal",   {"normal",   pos_sayto_msgtype, cmdarg_switch,   NULL, NULL, NULL, (gpointer)msgtype_normal}},
+    {'h', "headline", {"headline", pos_sayto_msgtype, cmdarg_switch,   NULL, NULL, NULL, (gpointer)msgtype_headline}},
+    {'d', "default",  {"default",  pos_sayto_msgtype, cmdarg_switch,   NULL, NULL, NULL, (gpointer)msgtype_not_set}},
+    {'q', "quiet",    {"quiet",    pos_sayto_quiet,   cmdarg_trigger,  NULL, NULL}},
+    {'e', "escapes",  {"escapes",  pos_sayto_esc,     cmdarg_trigger,  NULL, NULL}},
+    {'f', "file",     {"filename", pos_sayto_file,    cmdarg_required, NULL, &cmdarg_type_filename}},
+    {0}
+  },
+  (cmdarg_t[3]){
+    {"jid",     pos_sayto_jid, cmdarg_chreq, ".",  &cmdarg_type_fjid, (gpointer)cmdarg_roster_entity},
+    {"message", pos_sayto_msg, cmdarg_eol,   NULL, &cmdarg_type_nonspace},
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_say_to (const cmdopts_t *command, cmdarg_value_t *values)
 {
-  char **paramlst;
-  char *fjid, *msg_utf8;
-  char *msg;
-  char *unescaped_msg = NULL;
-  char *uncompletedfjid = NULL;
-  char *file = NULL;
-  LmMessageSubType msg_type = LM_MESSAGE_SUB_TYPE_NOT_SET;
-  bool quiet = FALSE;
-  bool eval = FALSE;
-
-  if (!xmpp_is_online()) {
-    scr_LogPrint(LPRINT_NORMAL, "You are not connected.");
-    return;
-  }
-
-  msg_type = scan_mtype(&arg);
-  paramlst = split_arg(arg, 2, 1); // jid, message (or option, jid, message)
-
-  if (!*paramlst) {  // No parameter?
-    scr_LogPrint(LPRINT_NORMAL, "Please specify a Jabber ID.");
-    free_arg_lst(paramlst);
-    return;
-  }
-
-  // Check for an option parameter
-  while (*paramlst) {
-    if (!strcmp(*paramlst, "-q")) {
-      char **oldparamlst = paramlst;
-      paramlst = split_arg(*(oldparamlst+1), 2, 1); // jid, message
-      free_arg_lst(oldparamlst);
-      quiet = TRUE;
-    } else if (!strcmp(*paramlst, "-e")) {
-      char **oldparamlst = paramlst;
-      paramlst = split_arg(*(oldparamlst+1), 2, 1); // jid, message
-      free_arg_lst(oldparamlst);
-      eval = TRUE;
-    } else if (!strcmp(*paramlst, "-f")) {
-      char **oldparamlst = paramlst;
-      paramlst = split_arg(*(oldparamlst+1), 2, 1); // filename, jid
-      free_arg_lst(oldparamlst);
-      if (!*paramlst) {
-        scr_LogPrint(LPRINT_NORMAL, "Wrong usage.");
-        free_arg_lst(paramlst);
-        return;
-      }
-      file = g_strdup(*paramlst);
-      // One more parameter shift...
-      oldparamlst = paramlst;
-      paramlst = split_arg(*(oldparamlst+1), 2, 1); // jid, nothing
-      free_arg_lst(oldparamlst);
-    } else
-      break;
-  }
-
-  if (!*paramlst) {
-    scr_LogPrint(LPRINT_NORMAL, "Wrong usage.");
-    free_arg_lst(paramlst);
-    return;
-  }
-
-  fjid = *paramlst;
-  msg = *(paramlst+1);
-
-  if (fjid[0] == '.') {
-    const gchar *cjid = (current_buddy ? CURRENT_JID : NULL);
-    if (fjid[1] == '\0') {
-      fjid = g_strdup(cjid);
-    } else if (fjid[1] == JID_RESOURCE_SEPARATOR) {
-      char *res_utf8 = to_utf8(fjid+2);
-      fjid = g_strdup_printf("%s%c%s", cjid, JID_RESOURCE_SEPARATOR, res_utf8);
-      g_free(res_utf8);
-    } else
-      fjid = to_utf8(fjid);
-  } else
-    fjid = to_utf8(fjid);
-
+  char *fjid, *msg, *file;
+  gchar *freeme  = NULL; // fjid
+  gchar *freeme2 = NULL; // msg
+  msgtype_t msg_type = (msgtype_t) (values[pos_sayto_msgtype].src -> userdata);
+
+  fjid = values[pos_sayto_jid].value.arg;
+  msg  = values[pos_sayto_msg].value.arg;
+  file = values[pos_sayto_file].value.fname.utf8;
+
+  // XXX this is not yet in default fjid checker. should we add it there?
   if (!strchr(fjid, JID_DOMAIN_SEPARATOR)) {
     const gchar *append_server = settings_opt_get("default_server");
     if (append_server) {
       gchar *res = strchr(fjid, JID_RESOURCE_SEPARATOR);
-      uncompletedfjid = fjid;
       if (res) {
         *res++ = '\0';
         fjid = g_strdup_printf("%s%c%s%c%s", fjid, JID_DOMAIN_SEPARATOR, append_server,
                                JID_RESOURCE_SEPARATOR, res);
       } else
         fjid = g_strdup_printf("%s%c%s", fjid, JID_DOMAIN_SEPARATOR, append_server);
+      g_free(freeme);
+      freeme = fjid;
     }
   }
 
-  if (check_jid_syntax(fjid)) {
-    scr_LogPrint(LPRINT_NORMAL, "Please specify a valid Jabber ID.");
-    free_arg_lst(paramlst);
-    g_free(uncompletedfjid);
-    g_free(fjid);
-    return;
-  }
-
-  if (!file) {
-    msg_utf8 = to_utf8(msg);
-    if (eval) {
-      unescaped_msg = ut_unescape_tabs_cr(msg_utf8);
+  if (file == NULL) {
+    if (values[pos_sayto_esc].value.swc) {
+      freeme2 = ut_unescape_tabs_cr(msg);
       // We must not free() if the original string was returned
-      if (unescaped_msg == msg_utf8)
-        unescaped_msg = NULL;
+      if (freeme2 == msg)
+        freeme2 = NULL;
+      else
+        msg = freeme2;
     }
-    msg = (unescaped_msg ? unescaped_msg : msg_utf8);
   } else {
-    char *filename_xp;
     if (msg)
       scr_LogPrint(LPRINT_NORMAL, "say_to: extra parameter ignored.");
-    filename_xp = expand_filename(file);
-    msg = msg_utf8 = load_message_from_file(filename_xp);
-    g_free(filename_xp);
-    g_free(file);
+    freeme2 = msg = load_message_from_file(file,
+                                           values[pos_sayto_file].value.fname.local);
   }
 
-  send_message_to(fjid, msg, NULL, msg_type, quiet);
-
-  g_free(uncompletedfjid);
-  g_free(fjid);
-  g_free(msg_utf8);
-  g_free(unescaped_msg);
-  free_arg_lst(paramlst);
+  send_message_to(fjid, msg, NULL, msg_type, values[pos_sayto_quiet].value.swc);
+
+  g_free(freeme);
+  g_free(freeme2);
+
+  return NULL;
 }
 
-//  buffer_updown(updown, nblines)
-// updown: -1=up, +1=down
-inline static void buffer_updown(int updown, char *nlines)
+//
+//  /buffer
+//
+
+static gchar *do_buffer (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  scmd_buffer_close, scmd_buffer_close_all,
+  scmd_buffer_clear, scmd_buffer_purge,
+  scmd_buffer_list,
+  scmd_buffer_top, scmd_buffer_bottom, scmd_buffer_up, scmd_buffer_down,
+  scmd_buffer_date, scmd_buffer_percent, scmd_buffer_readmark,
+  scmd_buffer_search_backward, scmd_buffer_search_forward,
+  scmd_buffer_scroll_lock, scmd_buffer_scroll_unlock,
+  scmd_buffer_scroll_toggle,
+  scmd_buffer_save,
+} scmd_buffer_t;
+
+typedef enum {
+  pos_buffer_scmd      = 0,
+  pos_buffer_jid       = 1,
+  pos_buffer_n         = 1,
+  pos_buffer_date      = 1,
+  pos_buffer_percent   = 1,
+  pos_buffer_text      = 1,
+  pos_buffer_file      = 1,
+} pos_buffer_t;
+
+static cmdopts_t def_buffer = {
+  "buffer",
+  cmd_default,
+  cmd_check_current_buddy,
+  do_buffer,
+  NULL,
+  (cmdarg_t[2]){
+    { "subcommand", pos_buffer_scmd, cmdarg_subcmd|cmdarg_chreq, NULL, NULL },
+    {NULL},
+  },
+  (cmdopts_t[19]){
+    { "close", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "jid", pos_buffer_jid, cmdarg_required, NULL, &cmdarg_type_roster_bjid, (gpointer)cmdarg_roster_buffer },
+        {NULL}
+      },
+      NULL, (gpointer)scmd_buffer_close },
+    { "close_all", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_close_all },
+    { "clear", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_clear },
+    { "purge", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "jid", pos_buffer_jid, cmdarg_required, NULL, &cmdarg_type_roster_bjid, (gpointer)cmdarg_roster_buffer },
+        {0}
+      },
+      NULL, (gpointer)scmd_buffer_purge },
+    { "list", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_list },
+    { "top",    cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_top    },
+    { "bottom", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_bottom },
+    { "up", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "n", pos_buffer_n, cmdarg_chreq, "0", &cmdarg_type_uint, (gpointer)0 },
+        {NULL}
+      },
+      NULL, (gpointer)scmd_buffer_up },
+    { "down", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "n", pos_buffer_n, cmdarg_chreq, "0", &cmdarg_type_uint, (gpointer)0 },
+        {NULL}
+      },
+      NULL, (gpointer)scmd_buffer_down },
+    { "date", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "date", pos_buffer_date, cmdarg_chreq, "1", &cmdarg_type_date },
+        {NULL}
+      },
+      NULL, (gpointer)scmd_buffer_date },
+    { "%", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "percent", pos_buffer_percent, cmdarg_chreq, "100", &cmdarg_type_uint, (gpointer)100 },
+        {NULL}
+      },
+      NULL, (gpointer)scmd_buffer_percent },
+    { "readmark", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_readmark },
+    { "search_backward", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "text", pos_buffer_text, cmdarg_chreq, NULL, &cmdarg_type_nonspace },
+        {NULL}
+      },
+      NULL, (gpointer)scmd_buffer_search_backward },
+    { "search_forward", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "text", pos_buffer_text, cmdarg_chreq, NULL, &cmdarg_type_nonspace },
+        {NULL}
+      },
+      NULL, (gpointer)scmd_buffer_search_forward },
+    { "scroll_lock",   cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_scroll_lock   },
+    { "scroll_unlock", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_scroll_unlock },
+    { "scroll_toggle", cmd_default, NULL, NULL, NULL, NULL, NULL, (gpointer)scmd_buffer_scroll_toggle },
+    { "save", cmd_default, NULL, NULL, NULL,
+      (cmdarg_t[2]){
+        { "filename", pos_buffer_file, cmdarg_chreq, NULL, &cmdarg_type_filename },
+        {NULL}
+      },
+      NULL, (gpointer)scmd_buffer_save },
+  },
+};
+
+// XXX % command before was able to handle %50
+static gchar *do_buffer (const cmdopts_t *command, cmdarg_value_t *values)
 {
-  int nblines;
-
-  if (!nlines || !*nlines)
-    nblines = 0;
-  else
-    nblines = strtol(nlines, NULL, 10);
-
-  if (nblines >= 0)
-    scr_buffer_scroll_up_down(updown, nblines);
+  scmd_buffer_t subcmd = (scmd_buffer_t) (values[pos_buffer_scmd].value.cmd -> userdata);
+
+  if (buddy_gettype(BUDDATA(current_buddy)) & ROSTER_TYPE_GROUP &&
+      subcmd != scmd_buffer_close_all) {
+    return g_strdup ("Groups have no buffer.");
+  }
+
+  if (subcmd == scmd_buffer_close) {
+    scr_buffer_purge(1, buddy_getjid(values[pos_buffer_jid].value.rjid.bud));
+  } else if (subcmd == scmd_buffer_close_all) {
+    scr_buffer_purge_all(1);
+  } else if (subcmd == scmd_buffer_clear) {
+    scr_buffer_clear();
+  } else if (subcmd == scmd_buffer_purge) {
+    scr_buffer_purge(0, buddy_getjid(values[pos_buffer_jid].value.rjid.bud));
+  } else if (subcmd == scmd_buffer_list) {
+    scr_buffer_list();
+  } else if (subcmd == scmd_buffer_top) {
+    scr_buffer_top_bottom(-1);
+  } else if (subcmd == scmd_buffer_bottom) {
+    scr_buffer_top_bottom(1);
+  } else if (subcmd == scmd_buffer_up) {
+    scr_buffer_scroll_up_down(-1, values[pos_buffer_n].value.uint);
+  } else if (subcmd == scmd_buffer_down) {
+    scr_buffer_scroll_up_down(1, values[pos_buffer_n].value.uint);
+  } else if (subcmd == scmd_buffer_date) {
+    scr_buffer_date(values[pos_buffer_date].value.time);
+  } else if (subcmd == scmd_buffer_percent) {
+    scr_buffer_percent(values[pos_buffer_percent].value.uint);
+  } else if (subcmd == scmd_buffer_readmark) {
+    scr_buffer_jump_readmark();
+  } else if (subcmd == scmd_buffer_search_backward) {
+    scr_buffer_search(-1, values[pos_buffer_text].value.arg);
+  } else if (subcmd == scmd_buffer_search_forward) {
+    scr_buffer_search(1, values[pos_buffer_text].value.arg);
+  } else if (subcmd == scmd_buffer_scroll_lock) {
+    scr_buffer_scroll_lock(1);
+  } else if (subcmd == scmd_buffer_scroll_unlock) {
+    scr_buffer_scroll_lock(0);
+  } else if (subcmd == scmd_buffer_scroll_toggle) {
+    scr_buffer_scroll_lock(-1);
+  } else { // scmd_buffer_save
+    scr_buffer_dump(values[pos_buffer_file].value.fname.local);
+  }
+
+  return NULL;
 }
 
-static void buffer_search(int direction, char *arg)
+//
+//  /clear
+//
+
+// XXX convert to real alias?
+static gchar *do_clear (const cmdopts_t *command, cmdarg_value_t *values);
+
+static cmdopts_t def_clear = {
+  "clear",
+  cmd_default,
+  cmd_check_current_buddy,
+  do_clear,
+  NULL,
+  NULL,
+  NULL,
+};
+
+// Alias for "buffer clear"
+static gchar *do_clear(const cmdopts_t *command, cmdarg_value_t *values)
 {
-  if (!arg || !*arg) {
-    scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-    return;
-  }
-
-  scr_buffer_search(direction, arg);
+  scr_buffer_clear();
+  return NULL;
 }
 
-static void buffer_date(char *date)
-{
-  time_t t;
-
-  if (!date || !*date) {
-    scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-    return;
-  }
-
-  strip_arg_special_chars(date);
-
-  t = from_iso8601(date, 0);
-  if (t)
-    scr_buffer_date(t);
-  else
-    scr_LogPrint(LPRINT_NORMAL, "The date you specified is "
-                 "not correctly formatted or invalid.");
-}
-
-static void buffer_percent(char *arg1, char *arg2)
-{
-  // Basically, user has typed "%arg1 arg2"
-  // "%50"  -> arg1 = 50, arg2 null pointer
-  // "% 50" -> arg1 = \0, arg2 = 50
-
-  if (!*arg1 && (!arg2 || !*arg2)) { // No value
-    scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-    return;
-  }
-
-  if (*arg1 && arg2 && *arg2) {     // Two values
-    scr_LogPrint(LPRINT_NORMAL, "Wrong parameters.");
-    return;
-  }
-
-  scr_buffer_percent(atoi((*arg1 ? arg1 : arg2)));
-}
-
-static void do_buffer(char *arg)
-{
-  char **paramlst;
-  char *subcmd;
-
-  if (!current_buddy)
-    return;
-
-  paramlst = split_arg(arg, 2, 1); // subcmd, arg
-  subcmd = *paramlst;
-  arg = *(paramlst+1);
-
-  if (!subcmd || !*subcmd) {
-    scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-    free_arg_lst(paramlst);
-    return;
-  }
-
-  if (buddy_gettype(BUDDATA(current_buddy)) & ROSTER_TYPE_GROUP &&
-      strcasecmp(subcmd, "close_all")) {
-    scr_LogPrint(LPRINT_NORMAL, "Groups have no buffer.");
-    free_arg_lst(paramlst);
-    return;
-  }
-
-  if (!strcasecmp(subcmd, "top")) {
-    scr_buffer_top_bottom(-1);
-  } else if (!strcasecmp(subcmd, "bottom")) {
-    scr_buffer_top_bottom(1);
-  } else if (!strcasecmp(subcmd, "clear")) {
-    scr_buffer_clear();
-  } else if (!strcasecmp(subcmd, "close")) {
-    scr_buffer_purge(1, arg);
-  } else if (!strcasecmp(subcmd, "close_all")) {
-    scr_buffer_purge_all(1);
-  } else if (!strcasecmp(subcmd, "purge")) {
-    scr_buffer_purge(0, arg);
-  } else if (!strcasecmp(subcmd, "scroll_lock")) {
-    scr_buffer_scroll_lock(1);
-  } else if (!strcasecmp(subcmd, "scroll_unlock")) {
-    scr_buffer_scroll_lock(0);
-  } else if (!strcasecmp(subcmd, "scroll_toggle")) {
-    scr_buffer_scroll_lock(-1);
-  } else if (!strcasecmp(subcmd, "up")) {
-    buffer_updown(-1, arg);
-  } else if (!strcasecmp(subcmd, "down")) {
-    buffer_updown(1, arg);
-  } else if (!strcasecmp(subcmd, "search_backward")) {
-    strip_arg_special_chars(arg);
-    buffer_search(-1, arg);
-  } else if (!strcasecmp(subcmd, "search_forward")) {
-    strip_arg_special_chars(arg);
-    buffer_search(1, arg);
-  } else if (!strcasecmp(subcmd, "date")) {
-    buffer_date(arg);
-  } else if (*subcmd == '%') {
-    buffer_percent(subcmd+1, arg);
-  } else if (!strcasecmp(subcmd, "save")) {
-    scr_buffer_dump(arg);
-  } else if (!strcasecmp(subcmd, "list")) {
-    scr_buffer_list();
-  } else if (!strcasecmp(subcmd, "readmark")) {
-    scr_buffer_jump_readmark();
-  } else {
-    scr_LogPrint(LPRINT_NORMAL, "Unrecognized parameter!");
-  }
-
-  free_arg_lst(paramlst);
-}
-
-static void do_clear(char *arg)    // Alias for "buffer clear"
-{
-  do_buffer("clear");
-}
-
-static void do_info(char *arg)
+//
+//  /info
+//
+
+static gchar *do_info (const cmdopts_t *command, cmdarg_value_t *values);
+
+static cmdopts_t def_info = {
+  "clear",
+  cmd_default,
+  cmd_check_current_buddy,
+  do_info,
+  NULL,
+  NULL,
+  NULL,
+};
+
+static gchar *do_info (const cmdopts_t *command, cmdarg_value_t *values)
 {
   gpointer bud;
   const char *bjid, *name;
@@ -1906,9 +2817,7 @@
   char *buffer;
   enum subscr esub;
 
-  if (!current_buddy)
-    return;
-  bud = BUDDATA(current_buddy);
+  bud    = BUDDATA(current_buddy);
 
   bjid   = buddy_getjid(bud);
   name   = buddy_getname(bud);
